----------------------------------------------------------------
-- Binary division for Polynomials(binary_algorithm_polynomials.adb)
-- 
-- Parameters and functions defined in Polynomials.ads and Polynomials.adb
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with Polynomials; use Polynomials;
procedure Binary_algorithm_Polynomials is
   A, B, C, D, F, G, H, Old_B, Old_D, Z, Y: Polynomial;
   Alpha, Beta, Old_Beta: Integer;
begin
--   for i in 0 .. m loop Put("F(");Put(i);Put(") = "); Get(x); F(i) := x; end loop; New_Line;
--   for i in 0 .. m-1 loop Put("H(");Put(i);Put(") = "); Get(x); H(i) := x; end loop; New_Line; --H(m) := 0;
--   for i in 0 .. m-1 loop Put("G(");Put(i);Put(") = "); Get(x); G(i) := x; end loop; New_Line; --G(m) := 0;

   ---------------------------------------------------------------------------
   F:= (1,1,0,1,1,0,0,0,1); -- F(x) = x^8 + x^4 + x^3 + x + 1
   H:= (1,1,1,1,1,1,1,1,0);
   G:= (1,0,0,0,0,0,0,0,0);
   ----------------------------------------------------------------------------
   A := F; B := H; C := Zero; D := G; Alpha := M; Beta := M-1;
   while Beta >= 0 loop
      if B(0) = 0 then 
         B := Shift_One(B); 
         D := Divide_By_X(D, F); 
         Beta := Beta - 1;
      else 
         Old_B := B; Old_D := D; Old_Beta := Beta;
         B := Shift_One(Add(A, B)); 
         D := Divide_By_X(Add(C, D),F);
         if Alpha > Beta then 
            A := Old_B; 
            C := Old_D; 
            Beta := Alpha - 1; 
            Alpha := Old_Beta;
         else
            Beta := Beta - 1; 
         end if; 
      end if;
   end loop;
   Z := C;
   -----------------------------------------------------------------------------
   Y := Product_Mod_F(Z, H, F);
   Put("g = "); for I in 0 .. M-1 loop Put(G(I)); Put("  "); end loop; New_Line;
   Put("h = "); for I in 0 .. M-1 loop Put(H(I)); Put("  "); end loop; New_Line;
   Put("z = "); for I in 0 .. M-1 loop Put(Z(I)); Put("  "); end loop; New_Line;
   Put("z.h = "); for I in 0 .. M-1 loop Put(Y(I)); Put("  "); end loop; New_Line;

end Binary_algorithm_Polynomials;