----------------------------------------------------------------
-- Mastrovito Multiplication second Version (mastrovito_multiplication_V2.adb)
-- 
-- parameters and functions defined in GF2m.ads
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with GF2m; use GF2m;
with finite_fields_GF2m; use finite_fields_GF2m;

procedure mastrovito_multiplication_v2 is
   a,b,f,c: poly_vector;
   R: poly_matrix_m1m2;
   D: poly_vector;
   E: poly_vector2;
   re: poly_vector;
   x: bit;

begin
   for j in 0 .. m-1 loop 
         c(j) := 0; 
         re(j) := 0;
   end loop;

--   for i in 0 .. m-1 loop 
--      Put("A(");Put(i);Put(") = "); Get(x); a(i) := x; 
--   end loop; New_Line;
--   
--   for i in 0 .. m-1 loop 
--      Put("B(");Put(i);Put(") = "); Get(x); b(i) := x; 
--   end loop; New_Line;
--   
--   for i in 0 .. m-1 loop 
--      Put("F(");Put(i);Put(") = "); Get(x); f(i) := x; 
--   end loop; New_Line;
   A:=(1,0,1,0,1,0,1,0);
   B:=(1,0,1,0,1,0,1,0);
   F:=(0,0,0,1,1,0,1,1); 

   D := vector_D(a,b);
   E := vector_E(a,b);
   R := reduction_matrix_R(f);
   
   for i in 0 .. m-1 loop
      for j in 0 .. m-2 loop
         re(i) := m2xor(re(i),m2and(R(i,j),E(j)));
      end loop;
   end loop;

   for i in 0 .. m-1 loop
      c(i) := m2xor(D(i),re(i));
   end loop;
            
-----------------------------------------------------
   
   Put("C = "); for i in 0 .. m-1 loop 
      Put(c(i)); 
   end loop; New_Line;

end mastrovito_multiplication_v2;