----------------------------------------------------------------
-- LSB first squaring (LSBfirst_squarer.adb)
-- 
-- 
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with GF2m; use GF2m;
with finite_fields_GF2m; use finite_fields_GF2m;


procedure LSBfirst_squarer is
   A,aux,C: poly_vector;
   F: poly_vector;

begin
-- loop

   for i in 0 .. m-1 loop Put("A(");Put(i);Put(") = "); Get(x); A(i) := x; Aux(i) := x; end loop; New_Line;
   for i in 0 .. m-1 loop Put("F(");Put(i);Put(") = "); Get(F(i)); end loop; New_Line;
--   A := (0,1,0,1,0,0,1,0);
--   F := (1,1,0,0,0,0,1,1); -- F(x) = x^8 + x^7 + x^6 + x + 1

   for i in 0 .. m-1 loop C(i) := 0; end loop;

   for i in 0 .. m-1 loop
      C := m2xvv(m2abv(Aux(i),A),C);
      A := Product_alpha_A(A,F);   
   end loop;   
      
-----------------------------------------------------
   Put("C = "); for i in 0 .. m-1 loop Put(C(i)); end loop; New_Line;
--   end loop;
end LSBfirst_squarer;