----------------------------------------------------------------
-- Inter-leaved Multiplication MSB-first (MSBfirst.adb)
-- 
-- 
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with GF2m; use GF2m;
with finite_fields_GF2m; use finite_fields_GF2m;

procedure MSBfirst is
   A,B,C: poly_vector;
-- F: constant poly_vector := (1,1,0,1,1,0,0,0);
   F: constant poly_vector := (0,0,0,1,1,0,1,1);
-- F(x) = x^8 + x^4 + x^3 + x + 1
   x: Bit;

begin
-- loop

--   for i in 0 .. m-1 loop Put("A(");Put(i);Put(") = "); Get(x); A(i) := x; end loop; New_Line;
--   for i in 0 .. m-1 loop Put("B(");Put(i);Put(") = "); Get(x); B(i) := x; end loop; New_Line;
   A:=(1,0,1,0,1,0,1,0);
   B:=(1,0,1,0,1,0,1,0);

   for i in 0 .. m-1 loop C(i) := 0; end loop;

   for i in reverse 0 .. m-1 loop
      C := m2xvv(Product_alpha_A(C,F), m2abv(B(i),A));
   end loop;   
      
-----------------------------------------------------
   Put("C = "); for i in 0 .. m-1 loop Put(C(i)); end loop; New_Line;
--   end loop;
end MSBfirst;