----------------------------------------------------------------
-- finite_fields_GF2m package body (finite_fields_GF2m.adb)
-- 
-- Defines several funtions for finite fields operations
-- of Chapter 7 examples
----------------------------------------------------------------
package body finite_fields_GF2m is   

   function m2xor(x, y: bit) return bit is
      z: bit;
   begin
      z := (x + y) mod 2;
      return z;
   end m2xor; 
   
   function m2and(x, y: bit) return bit is
      z: bit;
   begin
      z := (x * y) mod 2;
      return z;
   end m2and;
   
end finite_fields_GF2m;

