----------------------------------------------------------------
-- Mastrovito Multiplication (mastrovito_multiplication.adb)
-- 
-- parameters and functions defined in GF2m.ads
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with GF2m; use GF2m;
with finite_fields_GF2m; use finite_fields_GF2m;

procedure mastrovito_multiplication is
   a,b,f,c: poly_vector;
   P: poly_matrix_m2m1;
   Z: poly_matrix;
   x: Bit;

begin
   for j in 0 .. m-1 loop 
         C(j) := 0; 
   end loop;

   for i in 0 .. m-1 loop 
      Put("A(");Put(i);Put(") = "); Get(x); a(i) := x; 
   end loop; New_Line;
   
   for i in 0 .. m-1 loop 
      Put("B(");Put(i);Put(") = "); Get(x); b(i) := x; 
   end loop; New_Line;
   
   for i in 0 .. m-1 loop 
      Put("F(");Put(i);Put(") = "); Get(x); f(i) := x; 
   end loop; New_Line;
--   A:=(1,0,1,0,1,0,1,0);
--   B:=(1,0,1,0,1,0,1,0);
--   F:=(1,0,0,1,1,0,0,1); 

   P := matrix_P(f);
   Z := mastrovito_matrix(a,P);

   for i in 0 .. m-1 loop
      for j in 0 .. m-1 loop
         C(i) := m2xor(C(i),m2and(Z(i,j),b(j)));
      end loop;
   end loop;
            
-----------------------------------------------------
   
   Put("C = "); for i in 0 .. m-1 loop 
      Put(C(i)); 
   end loop; New_Line;

end mastrovito_multiplication;